//+------------------------------------------------------------------+
//|                                            MA5_GannHilo_PSAR.mq4 |
//|                      Copyright  2012, http://www.fx-mt4.info |
//+------------------------------------------------------------------+

#property copyright "FX-MT4.INFO"
#property link      "http://www.fx-mt4.info"

//+------------------------------------------------------------------+

extern int PerMA   = 5; // MA Period
extern int Method2 = 0;  //=SMA (Simple MA Mode)
extern int Pr2 = 0; // GannHilo Activator (Default)
extern int Lb = 10; // GannHilo Activator (Default)
extern int zs = 1;  // GannHilo Activator (Default)

extern double Lots=0.1;
extern int StopLoss_bye=70; // Initial Stop Loss
extern int StopLoss_sell=70;  // Initial Stop Loss
extern int TakeProfit_bye=500;
extern int TakeProfit_sell=500;
extern int Slippage=2;

extern double PSARStep = 0.02;  // PSAR Trailing Stop (Default)
extern double PSARMax =  0.2;    // PSAR Trailing Stop (Default)
extern bool CheckEveryTick = true;

extern int magic1=1234567;   // magic number

string strSymbol;

double TimePrev;
double ssl[10000],Hld,Hlv;
int first_b=0, first_s=0;

//+------------------------------------------------------------------+
//|                                                                    |
//+------------------------------------------------------------------+

int init()
  {
   ArraySetAsSeries(ssl,TRUE);
   return(0);
  }
  
//+------------------------------------------------------------------+
//|                                                                    |
//+------------------------------------------------------------------+

int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//                                                                     |
//+------------------------------------------------------------------+

int start()
  {int rs,rs2;
  
   if (TimePrev==Time[0]) return(0);

     int z=zs;
     int z1=z+1;

            double lr1=iCustom(NULL,0,"###Gann_HiLo_Activator_v2###",Lb,0,z);
            double lr1p=iCustom(NULL,0,"###Gann_HiLo_Activator_v2###",Lb,0,z1);
 
            double lr2=iMA(NULL,0,PerMA,0,Method2,Pr2,z);
            double lr2p=iMA(NULL,0,PerMA,0,Method2,Pr2,z1);

            bool Ob=lr1p>lr2p&&lr1<=lr2;
            bool Os=lr1p<lr2p&&lr1>=lr2;

   if(first_b==0)
   {
   if(Ob)
       {
      closeshrts();
      first_s=0;
         rs= OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Stoplong(Ask,StopLoss_bye),Ask+TakeProfit_bye*Point,NULL,magic1,0,Blue);
         first_b=0;
     }//long
   }

  if(first_s==0)
  { 
   if(Os)
     { first_b=0;
      closelongs();
         rs2=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Stopshrt(Bid,StopLoss_sell),Bid-TakeProfit_sell*Point,NULL,magic1,0,Red);
         first_s=0;
     }//shrt
  }   

    if(rs>=0&&rs2>=0) TimePrev=Time[0];  
         strSymbol = Symbol();

  if ((!CheckEveryTick) && (Volume[0]==1)) // Go for it on first tick only
    {
     MoveStopsToPSAR(magic1, 1);  
     return(0);
    }

  if(CheckEveryTick) MoveStopsToPSAR(magic1, 0); // Check for Stop move every tick
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double Stoplong(double price,int stop)
  {
   if(stop==0)
      return(0.0);
   return(price-(stop*Point));
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double Stopshrt(double price,int stop)
  {
   if (stop==0)
      return(0.0);
   return(price+(stop*Point));
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void closelongs()
  {
   int trade;
   int trades=OrdersTotal();
   for(trade=0;trade<trades;trade++)
     {
      OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol())
         continue;
      if(OrderType()==OP_BUY)
        { first_b=0;
        OrderClose(OrderTicket(),OrderLots(),Bid,0,Blue);
         }
     }//for
  }

//+------------------------------------------------------------------+
//                                                                   |
//+------------------------------------------------------------------+

void closeshrts()
  {
   int trade;
   int trades=OrdersTotal();
   for(trade=0;trade<trades;trade++)
     {
      OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol())
         continue;
      if(OrderType()==OP_SELL)
       { first_s=0;
         OrderClose(OrderTicket(),OrderLots(),Ask,0,Red);
       }
     }
  }

//+------------------------------------------------------------------+
//                                                                   |
//+------------------------------------------------------------------+

void MoveStopsToPSAR(int iMN, int iShift)
{
int icnt, itotal;
double ActiveSAR;
  double Close_1 = Close[iShift];
  ActiveSAR = iSAR(NULL,0,PSARStep,PSARMax,iShift);
   itotal=OrdersTotal();
   for(icnt=0;icnt<itotal;icnt++) 
     {                               // order loop boundary
      OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
       // check for opened position, symbol & MagicNumber
      if(OrderType()==OP_SELL && OrderSymbol()==strSymbol  && OrderMagicNumber()==iMN)  
        {         
           if ((ActiveSAR > Close_1) && (ActiveSAR!=OrderStopLoss())) OrderModify(OrderTicket(),OrderOpenPrice(),ActiveSAR,OrderTakeProfit(),0,Yellow);
        }
        
       if(OrderType()==OP_BUY && OrderSymbol()==strSymbol  && OrderMagicNumber()==iMN)  
        { 
          if ((ActiveSAR < Close_1) && (ActiveSAR!=OrderStopLoss())) OrderModify(OrderTicket(),OrderOpenPrice(),ActiveSAR,OrderTakeProfit(),0,White);
        }
     }  // order loop boundary
 }